package com.its.op.service.its.oper;

import com.its.op.dao.repository.its.oper.TbUserInfrRepository;
import com.its.op.dto.its.oper.TbUserGropMenuAthrDto;
import com.its.op.dto.its.oper.TbUserInfrDto;
import com.its.op.dto.its.oper.UserGropMenuInf;
import com.its.op.dto.its.oper.UserMenuDto;
import com.its.op.entity.its.oper.TbUserInfr;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbUserInfrService {

    private final TbUserInfrRepository repo;
    private final TbUserGropMenuAthrService menuService;

    // 데이터 1건 조회, 없으면 exception
    private TbUserInfr requireOne(String id) throws NoSuchElementException {
        Optional<TbUserInfr> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbUserInfrDto> findAll() {
        List<TbUserInfrDto> result = new ArrayList<>();
        List<TbUserInfr> data = this.repo.findAll();
        for (TbUserInfr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbUserInfrDto findById(String id) {
        TbUserInfr entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbUserInfrDto updateById(String id, TbUserInfrDto.TbUserInfrUpdReq req) {
        TbUserInfr entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbUserInfrDto> mergeInfoList(List<TbUserInfrDto.TbUserInfrUpdReq> reqList) {
        List<TbUserInfrDto> result = new ArrayList<>();
        for (TbUserInfrDto.TbUserInfrUpdReq req : reqList) {
            TbUserInfr obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbUserInfrDto mergeInfo(String id, TbUserInfrDto.TbUserInfrUpdReq req) {
        TbUserInfr obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbUserInfrDto deleteById(String id) {
        TbUserInfr entity = requireOne(id);
        entity.setDelete();
        //this.repo.deleteById(id);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbUserInfrDto> deleteByIds(List<String> ids) {
        List<TbUserInfrDto> result = new ArrayList<>();
        for (String id : ids) {
            deleteById(id);
//            Optional<TbUserInfr> obj = this.repo.findById(id);
//            if (obj.isPresent()) {
//                this.repo.deleteById(id);
//                result.add(obj.get().toDto());
//            }
        }
        return result;
    }

    // 운영자 비밀번호 변경
    @Transactional
    public TbUserInfrDto updatePswdById(String id, TbUserInfrDto.TbUserPswdUpdReq req) throws NoSuchElementException {

        TbUserInfr entity = requireOne(id);
        if (!entity.getPwd().equals(req.getOldPwd())) {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
        if (entity.getPwd().equals(req.getPwd())) {
            throw new NoSuchElementException("현재 비빌번호와 같습니다: " + id);
        }
        entity.updatePswd(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    /**
     * 사용자 접근 제한 메뉴 목록 조회
     * @param id
     * @return
     */
    @Transactional(readOnly = true)
    public List<UserMenuDto> findByIdMenuAthr(String id) {
        List<UserMenuDto> result = new ArrayList<>();
        List<UserGropMenuInf> data = this.repo.findByIdMenuAthr(id);
        data.forEach(obj -> {
            result.add(UserMenuDto.builder()
                    .menuId(obj.getMenuId())
                    .athrYn("N")
                    .build());
        });
        return result;
    }

    /**
     * 사용자에 대한 모든 메뉴 권한 정보를 리턴한다.
     * @param userId
     * @return
     */
    @Transactional(readOnly = true)
    public List<UserMenuDto> findUserMenuAuth(String userId) {
        List<UserMenuDto> result = new ArrayList<>();
        TbUserInfrDto user = findById(userId);
        List<TbUserGropMenuAthrDto> menuAthr = this.menuService.findAll();
        menuAthr.forEach(auth -> {
            if (StringUtils.equalsIgnoreCase(user.getGropId(), auth.getGropId())) {
                result.add(UserMenuDto.builder()
                        .menuId(auth.getMenuId())
                        .athrYn(auth.getAthrYn())
                        .build());
            }
        });
        return result;
    }
}
